$(function(){
	var $dateElement = $('#date'),
		$location = $('#location'),
		$vin = $('#vin'),
		$count = $('.write-count'),
		$back = $('.back-label'),
		$citys = $('.citys'),
		$submitBtn = $('.submit-btn'),
		$tel = $('#tel'),

		$vinDialog = $('#no-vin-dialog'),
		$vinDialogCancle = $('#no-vin-dialog .cancle'),
		$vinDialogConfirm = $('#no-vin-dialog .confirm'),

		$tipDialog = $('#tip-dialog'),
		$tipDialogClose = $('#tip-dialog .close-btn');

	var globalParam = {};
	var zhugeInfo = {};

	// 接口域名配置
	window.domain = 'http://dingjia.guchele.com';
	// 给默认城市列表加上事件
	citysAddEvent();
	window.initServicePage = function(domain){
		if(domain){
			window.domain = domain;
		}
		// 第一次静默加载
		getCityList();
	}
	// 测试代码
	// window.initServicePage();

	// 初始化日期选择器
	$dateElement.mobiscroll().date({
        theme: "ios",
        mode: "scroller",
        display: "bottom",
        lang: "zh",
        maxDate : new Date(),
        minDate : new Date(2004,12,30), //
	    onShow: function (event, inst) {
	    	if($(this).data('full')){
				$dateElement.mobiscroll('setVal', $(this).data('full'));
	    	}
	    	$(event.find('.dwwc .dwfl')[2]).hide()
	    },
	    onSelect : function(event, inst){
	    	inst.setVal(event.substring(0,7));
	    	$(this).data('full',event);
	    }
    });


	$dateElement.change(function(event){
		$(this).val($(this).val().substring(0,7));
	});

	// http://frontenddev.org/article/compatible-with-processing-and-chinese-input-method-to-optimize-the-input-events.html
	// 中文输入优化，我们想要的结果是只有词组进入了输入框才会触发事件
	var cpLock = false;

	$vin.on('compositionstart', function(event) {
		    cpLock = true;
	});

	$vin.on('compositionend', function(event) {
		    cpLock = false;
	});

	$vin.on('input',function(event){
		if(!cpLock){
			var value = $(vin).val();
			value = value.replace(/[^a-zA-Z0-9]/ig,'');
			$vin.val(value.toUpperCase().substring(0,17));
			$count.text($(vin).val().length);
			setTextValuePosition($vin[0], -1);  //设置到末尾
		}
	});

	$location.click(function(event){
		// 如果已经存在citys对象，直接渲染，不用ajax请求。
		if(!window.citys){
			getCityList();
		}

		$('.header').hide();
		$('.section').hide();
		$('.city-modal').show();
	});

	$back.click(function(event) {
		$('.header').show();
		$('.section').show();
		$('.city-modal').hide();
	});

	$submitBtn.click(function(event) {
		var vinCode = $vin.val(),
			date = $dateElement.val(),
			location = $location.val(),
			prov = $location.data('prov'),
			city = $location.data('city');

		if(!vinCode || vinCode.length < 17){
			showToast('请填写17位车架号')
			return;
		}

		if(!date){
			showToast('请选择上牌日期')
			return;
		}

		if(!location){
			showToast('请选择所在地区')
			return;
		}
		date = date.replace('/','-')+'-01';
		globalParam = {
			vin : vinCode,
			regDate : date,
			prov : prov,
			city : city
		};

		if(vinCode && date && location){
			zhugeInfo = {
				event : '评估贷款金额',
				key : '所在地区',
				value : location
			};
			// 判断登录状态
			window.JSLoginInterface.login();
		}
	});

	// 获取评估vin码结果
	window.vinAnalysis = function(){

		// 统计
		window.JSZhugeIOInterface.track(JSON.stringify(zhugeInfo));
		window.JSZhugeIOInterface.track('youmeng');

		// 显示loading
		window.JSDialogInterface.changeDialog('show');

		$.ajax({
			url: window.domain+'/demo/evaluate/calcLoanPrice',
			type: 'GET',
			dataType: 'jsonp',
        	jsonp: "jsoncallback",
			data: {
				vin : globalParam.vin,
				regDate : globalParam.regDate,
				prov : globalParam.prov,
				city : globalParam.city,
			},
			timeout : 10000, // 10秒延时
			success : function(res){
				//
				window.JSDialogInterface.changeDialog('hide');
				if(res && res.code == '2000' && res.data){
					zhugeInfo = {
						event : '评估贷款金额',
						key : '查询状态',
						value : '查询成功'
					};
					window.JSZhugeIOInterface.track(JSON.stringify(zhugeInfo));
					var data = {
						lowPrice : res.data['low_price'],
						highPrice : res.data['high_price'],
						brand_id : res.data['brand_id'],
						brand_name : res.data['brand_name'],
						series_id : res.data['series_id'],
						series_name : res.data['series_name'],
						carName : res.data['car_name'],
					};
					$.extend(true, globalParam, data);
					window.FinanceService.gotoFinancialEvaluation(JSON.stringify(globalParam));
				} else if(res && res.code == '3000'){
					showToast(res.msg || '车架号不合法');
				} else {
					zhugeInfo = {
						event : '评估贷款金额',
						key : '查询状态',
						value : '查询失败'
					};
					window.JSZhugeIOInterface.track(JSON.stringify(zhugeInfo));
					var userInfo = JSON.parse(window.JSUserInfoInterface.getUserInfo());
					globalParam = {
						vin : globalParam.vin,
						reg_date : globalParam.regDate,
						prov_id : globalParam.prov,
						city_id : globalParam.city
					};
					$.extend(true, globalParam, {
						user_id : userInfo.user_id,
						user_tel : userInfo.user_tel
					});
					$vinDialog.show();
				}
			},error:function(e){
				zhugeInfo = {
					event : '评估贷款金额',
					key : '查询状态',
					value : '网络失败'
				};
				window.JSZhugeIOInterface.track(JSON.stringify(zhugeInfo));
				window.JSDialogInterface.changeDialog('hide');
				showToast('网络请求失败，请重试')
			}
		});
	}

	$tel.on('input',function(event){
		var value = $tel.val();
		value = value.replace(/[^0-9]/ig,'');
		$tel.val(value);
	});

	$vinDialogConfirm.click(function(event) {
		var tel = $vinDialog.find('input').val();
		zhugeInfo = {
			event : '提交贷款申请',
			key : '来源',
			value : '金融首页'
		};
		window.JSZhugeIOInterface.track(JSON.stringify(zhugeInfo));
		if(validMobileFormat(tel)){
			$.extend(true, globalParam, {
				mobile : tel
			});
			window.JSDialogInterface.changeDialog('show');
			$.ajax({
				url : window.domain+'/demo/api_finance',
				type : 'post',
				dataType: 'jsonp',
            	jsonp: "jsoncallback",
            	data : globalParam,
				timeout : 10000, // 10秒延时
				success : function(res){
					window.JSDialogInterface.changeDialog('hide');
					if(res.status){
						$vinDialog.hide();
						$tipDialog.show();
					} else {
						showToast('提交失败，请重试');
						// showToast(res.msg);
					}
				},error : function(e){
					window.JSDialogInterface.changeDialog('hide');
					showToast('网络连接失败，请重试');
				}
			})
		} else {
			showToast('请输入正确的手机号码');
		}
	});

	$vinDialogCancle.click(function(event) {
		$vinDialog.hide();
	});

	$tipDialogClose.click(function(event) {
		$tipDialog.hide();
	});

	/**
	 * 设置文字光标位置
	 **/
	function setTextValuePosition(obj, spos){
	    var tobj = obj;
	    if(spos<0)
	            spos = tobj.value.length;
	    if(tobj.setSelectionRange){ //兼容火狐,谷歌
	            setTimeout(function(){
	                tobj.setSelectionRange(spos, spos);
	                tobj.focus();}
	                ,0);
	    }else if(tobj.createTextRange){ //兼容IE
	            var rng = tobj.createTextRange();
	            rng.move('character', spos);
	            rng.select();
	    }
	}

    /*验证手机号*/
    function validMobileFormat(mobile) {
        var numberRegStr = /^\d{11}$/;
        var regNum = new RegExp(numberRegStr);
        if (regNum.test(mobile)) {
            var telRegStr = /^(13|14|18|15|17)\d{9}$/;
            var reg = new RegExp(telRegStr);
            return reg.test(mobile);
        } else {
            return false;
        }
    }

	function showToast(text){
		// $.toast({
		// 	text:text
		// })
		// 原生Toast
		window.JSToastInterface.show(text);
	}

	/*获取城市列表*/
	function getCityList(domain){
		$.ajax({
			url: window.domain+'/demo/api_finance/get_city_list',
			type: 'post',
			dataType: 'jsonp',
        	jsonp: "jsoncallback",
			data: {
				financing_enabled : 1
			},
			timeout : 10000, // 10秒延时
			success : function(res){
				if(res.status){
					window.citys = res.data;
					renderCitys(window.citys);
					$location.val('');
					$location.data('prov','');
					$location.data('city','');
				}
			},error:function(e){
			}
		});
	}

	/*渲染新的城市列表*/
	function renderCitys(cityList){
		$citys.empty();
		cityList && cityList.forEach(function(item){
			$citys.append('<p class="item" data-prov="'+item['prov_id']+'" data-city="'+item['city_id']+'">'+item['city_name']+'</p>');
		});
		citysAddEvent();
	}

	/*各城市列表添加点击事件*/
	function citysAddEvent(){
		$('.citys .item').on('click',function(event) {
			/* Act on the event */
			$location.val($(event.target).text());

			$location.data('prov', $(event.target).data('prov'));
			$location.data('city', $(event.target).data('city'));

			$('.header').show();
			$('.section').show();
			$('.city-modal').hide();
			$(document).scrollTop(1000);
		});
	}
});