/**
 * toast 提示
 */
(function($) {
    $.extend({
        //插件名字
        toast: function(options) {
            //设置默认值并用逗号隔开
            var defaults = {
                text: '', // 显示文案
                hideDuration: 1, // 多少秒之后隐藏
                animateDuration: 1 // 隐藏动画的持续时间
            };

            var options = $.extend(defaults, options);
            var $toast = $('.toast-control');

            if ($toast.length > 0) {
                $toast.find('.tip').text(options.text).show();
            } else {
                $('body').append('<div class="toast-control mask-control"><p class="tip">' + options.text + '</p></div>');
                $toast = $('.toast-control');
            }

            // 当前页面的最大z-index
            var maxZIndex = Math.max.apply(null, $.map($('body > *'), function(e, n) {
                // 排除当前控件
                if(!$(e).hasClass('toast-control')){
                    return parseInt($(e).css('z-index')) || 1;
                }
            }));

            $toast.css({
                'opacity' : 1,
                'z-index' : maxZIndex + 1
            }).show();

            setTimeout(function() {
                $toast.animate({
                    opacity: 0
                }, options.animateDuration*1000, 'linear', function() {
                    $toast.hide();
                });
            }, options.hideDuration*1000);
        }
    });
})(jQuery);